/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: setCharOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the setCharOperationDispatcher. It contains of all the generic methods
    for setCharOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setCharOperationDispatcher_HXX
#define setCharOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setCharOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setCharOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        setCharOperationDispatcher();
        virtual ~setCharOperationDispatcher();
        static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setCharPreConditions( Teamcenter::BusinessObject* obj, const char charValue, const bool isNull ) const;
    void setCharPreActions( Teamcenter::BusinessObject* obj, const char charValue, const bool isNull ) const;
    void setCharBaseAction( Teamcenter::BusinessObject* obj, const char charValue, const bool isNull ) const;
    void setCharPostActions( Teamcenter::BusinessObject* obj, const char charValue, const bool isNull ) const;

    // Project 011450 changes
    void setCharPreConditions( METHOD_message_t* msgData, const char charValue, const logical isNull ) const;
    void setCharPreActions( METHOD_message_t* msgData, const char charValue, const logical isNull ) const;
    void setCharPostActions( METHOD_message_t* msgData, const char charValue, const logical isNull ) const;
    void setCharBaseAction( METHOD_message_t* msgData, const char charValue, const logical isNull ) const;

    void setChar( Teamcenter::BusinessObject* obj, const char charValue, const bool isNull ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setCharOperationDispatcher_HXX
